/* 

Circle Fermenter V0.05
missing display feature, controllig knob and multiple fermenters

  created by Matteo Cappellari
  with the collaboration of Polifactory within the Distributed Design Platform


  released under Creative Commons Licence (CC-BY)

  enjoy the fermentation :) 

*/


int temperatura = 30; // temperatura target in gradi celsius
int umidita = 90;// umidità target in percentuale 

int tol_temp = 1;
int tol_h = 1;
int ptc_safety = 20;
// 
int vaporizzatore = 33; //pin vaporizzatore
const int ptc = 32; //pin ptc



//sensore di temperatura e umidità DHT22
#include "DHT.h"
#define DHTPIN 4
#define DHTTYPE DHT22
DHT dht(DHTPIN, DHTTYPE);


//termistore di sicurezza
const double VCC = 3.3;             // NodeMCU on board 3.3v vcc
const double R2 = 10000;            // 10k ohm series resistor
const double adc_resolution = 4095; // 10-bit adc

//const double A = 0.001125308852122;   // thermistor equation parameters
//const double B = 0.000234711863267;
//const double C = 0.000000085663516; 


const double A = 0.001129;   // thermistor equation parameters
const double B = 0.000234;
const double C = 0.0000000876741;


//pin analogici
const int ch0 = 0;
const int frequency = 5000;
const int resolution = 8;

void setup() {
   Serial.begin(115200);
   
   //DHT
  Serial.println(F("DHTxx test!"));
  dht.begin();

//pin analogici
  pinMode(ptc, OUTPUT);
  ledcSetup(ch0,frequency, resolution);
  ledcAttachPin(ptc,ch0);

//pin di controllo
  pinMode(vaporizzatore, OUTPUT);
 

//setup dei pin
  digitalWrite(vaporizzatore, LOW);
  digitalWrite(ptc, LOW);
}

void loop() {
  // LETTURA DHT
  delay(2000);
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  float f = dht.readTemperature(true);
  // Check if any reads failed and exit early (to try again).
  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println(F("Failed to read from DHT sensor!"));
    return;
  }
  // Compute heat index in Fahrenheit (the default)
  float hif = dht.computeHeatIndex(f, h);
  // Compute heat index in Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);
  Serial.print(F("Humidity: "));
  Serial.print(h);
  Serial.print(F("%  Temperature: "));
  Serial.print(t);
  Serial.print(F("°C "));
  Serial.print(f);
  Serial.print(F("°F  Heat index: "));
  Serial.print(hic);
  Serial.print(F("°C "));
  Serial.print(hif);
  Serial.println(F("°F"));
//TERMISTORE
  double Vout, Rth, temperature, adc_value; 

  adc_value = analogRead(2);

  if (adc_value > 0 && adc_value < adc_resolution) {
    Vout = (adc_value * VCC) / adc_resolution;
    Rth = (VCC * R2 / Vout) - R2;

    temperature = 1 / (A + (B * log(Rth)) + (C * pow(log(Rth), 3)));
    temperature -= 273.15;

    // Check if temperature is valid (not NaN)
    if (!isnan(temperature)) {
      Serial.print("Termistore sicurezza = ");
      Serial.print(temperature);
      Serial.println("°C");
    } else {
      Serial.println("Error: Temperature calculation resulted in NaN");
    }
  } else {
    Serial.println("Error: Invalid ADC value");
  }

//produzione umidità 
if (h < (umidita - tol_h)) {
    digitalWrite(vaporizzatore, HIGH);  // Turn the pin high

  }else if (h > (umidita + tol_h)) {
    digitalWrite(vaporizzatore, LOW);   // Turn the pin low
  }

//produzione calore

if (t < (temperatura - tol_temp)) {
    ledcWrite(ch0, 200);  // Turn the pin high
    //digitalWrite(ptc, HIGH);
  } else if (t > (temperatura + tol_temp)) {
    ledcWrite(ch0, 0); 

//sicurezza ptc
 const double safety_threshold = ptc_safety;  // Set your safety temperature threshold
 if (temperature > safety_threshold) {
  digitalWrite(ptc, LOW);  // Turn the PTC pin low as a safety measure
  }


}
}
